#pragma once

#include <Color4.hpp>
#include <Colors.hpp>

namespace JUI {

    class RectStyler {
    public:
#pragma region Getters
        virtual Color4 BGColor() const = 0;
        virtual Color4 BorderColor() const = 0;
        virtual enum BorderMode BorderMode() const = 0;
        virtual float BorderWidth() const = 0;
        virtual float CornerRounding() const = 0;
#pragma endregion
#pragma region Setters
        virtual void BGColor(const Color4& color) = 0;
        virtual void BorderColor(const Color4& color) = 0;
        virtual void BorderMode(const enum BorderMode& borderMode) = 0;
        virtual void BorderWidth(float width) = 0;
#pragma endregion

    protected:
        float border_width = 1.f;
        Color4 border_color {192, 192, 192};
        enum BorderMode border_mode;
        float corner_rounding = 0.f;
    private:
    };
}